<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="DoxyPress 1.2.10"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>Commanders: D:/Mes documents/Trusty/Arduino/Libraries/Commanders/src/EventStack.cpp Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="navtree.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="resize.js"></script>
<script type="text/javascript" src="navtreedata.js"></script>
<script type="text/javascript" src="navtree.js"></script>
<script type="text/javascript">
  $(document).ready(initResizable);
  $(window).load(resizeHeight);
</script>
<link href="doxypress.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by DoxyPress -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">Commanders
   </div>
   <div id="projectbrief">Arduino buttons/bus library</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by DoxyPress 1.2.10 -->
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" 
       class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
$(document).ready(function(){initNavTree('EventStack_8cpp_source.html','');});
</script>
<div id="doc-content">
<div class="header">
  <div class="headertitle">
<div class="title">EventStack.cpp</div>  </div>
  <div class="clear-floats"></div>
</div><!--header-->
<div class="contents">
<div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;<span class="preprocessor">#include &quot;EventStack.hpp&quot;</span></div><div class="line"><a name="l00002"></a><span class="lineno">    2</span>&#160;</div><div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160;<a class="code" href="classEventStack.html">EventStack</a> <a class="code" href="classEventStack.html#aa069fd5ec754f59e4285bc3a38ff1b78">EventStack::EventsStack</a>;</div><div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160;</div><div class="line"><a name="l00005"></a><span class="lineno">    5</span>&#160;<span class="keywordtype">void</span> EventStack::FreeEvent(byte inEvent) </div><div class="line"><a name="l00006"></a><span class="lineno">    6</span>&#160;{</div><div class="line"><a name="l00007"></a><span class="lineno">    7</span>&#160;    <span class="keywordtype">id</span>[inEvent] = <a class="code" href="Events_8h.html#a48ad4dd16b8e22f2c8bc92b154479e92">UNDEFINED_ID</a>;</div><div class="line"><a name="l00008"></a><span class="lineno">    8</span>&#160;    type[inEvent] = <a class="code" href="Events_8h.html#a36239a7eea6194f04e73e80d7419490ca4e8b4f5861d5b6bb06b4460524e526b7">COMMANDERS_EVENT_NONE</a>;</div><div class="line"><a name="l00009"></a><span class="lineno">    9</span>&#160;    data[inEvent] = 0; </div><div class="line"><a name="l00010"></a><span class="lineno">   10</span>&#160;}</div><div class="line"><a name="l00011"></a><span class="lineno">   11</span>&#160;</div><div class="line"><a name="l00012"></a><span class="lineno"><a class="line" href="classEventStack.html#ae68541fb067cda62a399a9cea46ca202">   12</a></span>&#160;<span class="keywordtype">void</span> <a class="code" href="classEventStack.html#ae68541fb067cda62a399a9cea46ca202">EventStack::PushEvent</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> inId, <a class="code" href="Events_8h.html#a36239a7eea6194f04e73e80d7419490c">COMMANDERS_EVENT_TYPE</a> inType, <span class="keywordtype">int</span> inData)</div><div class="line"><a name="l00013"></a><span class="lineno">   13</span>&#160;{</div><div class="line"><a name="l00014"></a><span class="lineno">   14</span>&#160;    <span class="keywordflow">for</span> (<span class="keywordtype">int</span> i =0; i &lt; EVENT_MAXNUMBER; i++)</div><div class="line"><a name="l00015"></a><span class="lineno">   15</span>&#160;        <span class="keywordflow">if</span> (this-&gt;<span class="keywordtype">id</span>[i] == <a class="code" href="Events_8h.html#a48ad4dd16b8e22f2c8bc92b154479e92">UNDEFINED_ID</a>)</div><div class="line"><a name="l00016"></a><span class="lineno">   16</span>&#160;        {</div><div class="line"><a name="l00017"></a><span class="lineno">   17</span>&#160;            this-&gt;<span class="keywordtype">id</span>[i] = inId;</div><div class="line"><a name="l00018"></a><span class="lineno">   18</span>&#160;            this-&gt;type[i] = inType;</div><div class="line"><a name="l00019"></a><span class="lineno">   19</span>&#160;            this-&gt;data[i] = inData;</div><div class="line"><a name="l00020"></a><span class="lineno">   20</span>&#160;            <span class="keywordflow">return</span>;</div><div class="line"><a name="l00021"></a><span class="lineno">   21</span>&#160;        }</div><div class="line"><a name="l00022"></a><span class="lineno">   22</span>&#160;</div><div class="line"><a name="l00023"></a><span class="lineno">   23</span>&#160;<span class="preprocessor">#ifdef COMMANDERS_DEBUG_MODE</span></div><div class="line"><a name="l00024"></a><span class="lineno">   24</span>&#160;    Serial.println(F(<span class="stringliteral">&quot;Error : an event has been lost ! Stack is full !&quot;</span>));</div><div class="line"><a name="l00025"></a><span class="lineno">   25</span>&#160;<span class="preprocessor">#endif</span></div><div class="line"><a name="l00026"></a><span class="lineno">   26</span>&#160;}</div><div class="line"><a name="l00027"></a><span class="lineno">   27</span>&#160;</div><div class="line"><a name="l00028"></a><span class="lineno"><a class="line" href="classEventStack.html#ac926c16835a21a1710d986040ce76b57">   28</a></span>&#160;byte <a class="code" href="classEventStack.html#ac926c16835a21a1710d986040ce76b57">EventStack::GetPendingEventIndex</a>()</div><div class="line"><a name="l00029"></a><span class="lineno">   29</span>&#160;{</div><div class="line"><a name="l00030"></a><span class="lineno">   30</span>&#160;    <span class="keywordflow">for</span> (<span class="keywordtype">int</span> i = 0; i &lt; EVENT_MAXNUMBER; i++)</div><div class="line"><a name="l00031"></a><span class="lineno">   31</span>&#160;        <span class="keywordflow">if</span> (this-&gt;<span class="keywordtype">id</span>[i] != <a class="code" href="Events_8h.html#a48ad4dd16b8e22f2c8bc92b154479e92">UNDEFINED_ID</a>)</div><div class="line"><a name="l00032"></a><span class="lineno">   32</span>&#160;            <span class="keywordflow">return</span> i;</div><div class="line"><a name="l00033"></a><span class="lineno">   33</span>&#160;</div><div class="line"><a name="l00034"></a><span class="lineno">   34</span>&#160;    <span class="keywordflow">return</span> 255;</div><div class="line"><a name="l00035"></a><span class="lineno">   35</span>&#160;}</div><div class="line"><a name="l00036"></a><span class="lineno">   36</span>&#160;</div><div class="line"><a name="l00037"></a><span class="lineno"><a class="line" href="classEventStack.html#a0cd732c42b231ae7e31ec5b77d23faec">   37</a></span>&#160;<span class="keywordtype">void</span> <a class="code" href="classEventStack.html#a0cd732c42b231ae7e31ec5b77d23faec">EventStack::GetEvent</a>(byte inEvent, <span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> *inpId, <a class="code" href="Events_8h.html#a36239a7eea6194f04e73e80d7419490c">COMMANDERS_EVENT_TYPE</a> *inpType, <span class="keywordtype">int</span> *inpData)</div><div class="line"><a name="l00038"></a><span class="lineno">   38</span>&#160;{</div><div class="line"><a name="l00039"></a><span class="lineno">   39</span>&#160;    *inpId = this-&gt;<span class="keywordtype">id</span>[inEvent];</div><div class="line"><a name="l00040"></a><span class="lineno">   40</span>&#160;    *inpType = this-&gt;type[inEvent];</div><div class="line"><a name="l00041"></a><span class="lineno">   41</span>&#160;    *inpData = this-&gt;data[inEvent];</div><div class="line"><a name="l00042"></a><span class="lineno">   42</span>&#160;    this-&gt;FreeEvent(inEvent);</div><div class="line"><a name="l00043"></a><span class="lineno">   43</span>&#160;}</div><div class="ttc" id="classEventStack_html_a0cd732c42b231ae7e31ec5b77d23faec"><div class="ttname"><a href="classEventStack.html#a0cd732c42b231ae7e31ec5b77d23faec">EventStack::GetEvent</a></div><div class="ttdeci">void GetEvent(byte inIndex, unsigned long *inpId, COMMANDERS_EVENT_TYPE *inpType, int *inpData)</div><div class="ttdef"><b>Definition:</b> <a href="EventStack_8cpp_source.html#l00037">EventStack.cpp:37</a></div></div>
<div class="ttc" id="classEventStack_html_ac926c16835a21a1710d986040ce76b57"><div class="ttname"><a href="classEventStack.html#ac926c16835a21a1710d986040ce76b57">EventStack::GetPendingEventIndex</a></div><div class="ttdeci">byte GetPendingEventIndex()</div><div class="ttdef"><b>Definition:</b> <a href="EventStack_8cpp_source.html#l00028">EventStack.cpp:28</a></div></div>
<div class="ttc" id="Events_8h_html_a36239a7eea6194f04e73e80d7419490c"><div class="ttname"><a href="Events_8h.html#a36239a7eea6194f04e73e80d7419490c">COMMANDERS_EVENT_TYPE</a></div><div class="ttdeci">COMMANDERS_EVENT_TYPE</div><div class="ttdef"><b>Definition:</b> <a href="Events_8h_source.html#l00025">Events.h:25</a></div></div>
<div class="ttc" id="classEventStack_html_ae68541fb067cda62a399a9cea46ca202"><div class="ttname"><a href="classEventStack.html#ae68541fb067cda62a399a9cea46ca202">EventStack::PushEvent</a></div><div class="ttdeci">void PushEvent(unsigned long inId, COMMANDERS_EVENT_TYPE inType, int inData)</div><div class="ttdef"><b>Definition:</b> <a href="EventStack_8cpp_source.html#l00012">EventStack.cpp:12</a></div></div>
<div class="ttc" id="Events_8h_html_a36239a7eea6194f04e73e80d7419490ca4e8b4f5861d5b6bb06b4460524e526b7"><div class="ttname"><a href="Events_8h.html#a36239a7eea6194f04e73e80d7419490ca4e8b4f5861d5b6bb06b4460524e526b7">COMMANDERS_EVENT_NONE</a></div><div class="ttdef"><b>Definition:</b> <a href="Events_8h_source.html#l00027">Events.h:27</a></div></div>
<div class="ttc" id="Events_8h_html_a48ad4dd16b8e22f2c8bc92b154479e92"><div class="ttname"><a href="Events_8h.html#a48ad4dd16b8e22f2c8bc92b154479e92">UNDEFINED_ID</a></div><div class="ttdeci">#define UNDEFINED_ID</div><div class="ttdef"><b>Definition:</b> <a href="Events_8h_source.html#l00038">Events.h:38</a></div></div>
<div class="ttc" id="classEventStack_html_aa069fd5ec754f59e4285bc3a38ff1b78"><div class="ttname"><a href="classEventStack.html#aa069fd5ec754f59e4285bc3a38ff1b78">EventStack::EventsStack</a></div><div class="ttdeci">static EventStack EventsStack</div><div class="ttdef"><b>Definition:</b> <a href="EventStack_8hpp_source.html#l00036">EventStack.hpp:36</a></div></div>
<div class="ttc" id="classEventStack_html"><div class="ttname"><a href="classEventStack.html">EventStack</a></div><div class="ttdef"><b>Definition:</b> <a href="EventStack_8hpp_source.html#l00019">EventStack.hpp:19</a></div></div>
</div><!-- fragment --></div><!-- contents -->
</div><!-- doc-content -->
<!-- Generated by DoxyPress 1.2.10 -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
  <ul>
    <li class="navelem"><a class="el" href="dir_d41d8cd98f00b204e9800998ecf8427e.html">src</a></li><li class="navelem"><b>EventStack.cpp</b></li>
    <li class="footer">Generated on mer. oct. 18 2017 17:55:02 for Commanders &nbsp; by
    <a href="http://www.copperspice.com/documentation-doxypress.html">
    <img class="footer" src="doxypress.png" alt="DoxyPress"/></a> 1.2.10 </li>
  </ul>
</div>
</body>
</html>
